/*
 * SirvNET Services are copyright (c) 1998-2006 Trevor Klingbeil.
 *    http://www.sirv.net  ::  ftp.sirv.net
 * This program is copyrighted software; see the file COPYING for details.
 */

/*    ATTENTION   ATTENTION   ATTENTION  ATTENTION  ATTENTION
*
*     If you don't know what you're doing, DO NOT modify this file.
*     Modifications may cause unpredictable results, and I will not
*     take responsibility for it!. Do NOT send me bug reports of
*     errors if its related to this.
*
*
*       \2 - [^B]  Bold          \15 - [^O] Reset format
*       \22 -[^V]  Reverse       \37 - [^_] Underline
*
*           %s - string         %d - integer
*
*    For those of you that wish to use mIRC colour codes,
*    use the following syntax:     (Not Recommended)
*
*      \003# - Foreground    \003#,# - Foreground,Background
*
*      0  - White               8  - Yellow
*      1  - Black               9  - Light Green
*      2  - Blue                10 - Cyan
*      3  - Green               11 - Light Cyan
*      4  - Light Red           12 - Light Blue
*      5  - Brown               13 - Pink
*      6  - Purple              14 - Grey
*      7  - Orange              15 - Light Grey
*
*   NOTE: Numbers can NOT be followed after a colour code.
*/



/*****************************************************************/
/*****************************************************************/

#ifndef MESSAGES_H
#define MESSAGES_H


#define E extern



typedef struct {
	const char *name;
	void (*func)(char *source, int ac, char **av);
} Message;

E Message messages[];
E Message *find_message(const char *name);


/* NickServ Oper OHELP Strings */

#define NS_OHELP_ACC          ""
#define NS_OHELP_ACCESS       ""
#define NS_OHELP_AUTH         ""
#define NS_OHELP_AUTHINFO     " Retrieve authorization information on a nick."
#define NS_OHELP_DROP         ""
#define NS_OHELP_DELETE       "   Remove a nick from all database records."
#define NS_OHELP_FLIST        "    View listing of nicks with specific special flag setting."
#define NS_OHELP_FLUSH        "    Reset a nick's authorization setting."
#define NS_OHELP_FORBID       "   Render a nick impossible to use."
#define NS_OHELP_FREEZE       "   Temporarily suspend a nick."
#define NS_OHELP_GETEMAIL     " Retrieve a nick's e-mail address."
#define NS_OHELP_GETPASS      "  Retrieve a nick's password."
#define NS_OHELP_GHOST        ""
#define NS_OHELP_HELP         ""
#define NS_OHELP_HOLD         "     Prevent a nick from expiring. "
#define NS_OHELP_IDENTIFY     ""
#define NS_OHELP_ID           ""
#define NS_OHELP_INFO         ""
#define NS_OHELP_LIST         "     List all registered nicknames."
#define NS_OHELP_LISTCHANS    ""
#define NS_OHELP_LISTEMAIL    "List all registrations with given e-mail address."
#define NS_OHELP_MARK         "     Flag a nick as 'Marked'."
#define NS_OHELP_MYQUESTION  ""
#define NS_OHELP_OHELP        "    To see this help message."
#define NS_OHELP_RECOVER      ""
#define NS_OHELP_REGISTER     ""
#define NS_OHELP_RELEASE      ""
#define NS_OHELP_SENDPASS     ""
#define NS_OHELP_SET          ""
#define NS_OHELP_SIDENTIFY    ""


#define CS_OHELP_AKICK        ""
#define CS_OHELP_AOP          ""
#define CS_OHELP_AVOICE       ""
#define CS_OHELP_CF           ""
#define CS_OHELP_CFOUNDER     ""
#define CS_OHELP_CLEAR        ""
#define CS_OHELP_CLOSE        "   Close a channel from use."
#define CS_OHELP_COUNT        ""
#define CS_OHELP_DELETE       "  Remove a channel from all database records."
#define CS_OHELP_DEOP         ""
#define CS_OHELP_DROP         ""
#define CS_OHELP_EXPEL        "   Wipe channel modes/users."
#define CS_OHELP_FLIST        "   View channels with special flag settings."
#define CS_OHELP_FREEZE       "  Prevent ChanServ from interacting with a channel."
#define CS_OHELP_GETPASS      " Retrieve a channel's password."
#define CS_OHELP_HELP         ""
#define CS_OHELP_HOLD         "    Prevent a channel from expiring."
#define CS_OHELP_HOP          ""
#define CS_OHELP_IDENTIFY     ""
#define CS_OHELP_ID           ""
#define CS_OHELP_INFO         ""
#define CS_OHELP_INVITE       ""
#define CS_OHELP_LEVEL        "   Restrict a channel to an oper access level."
#define CS_OHELP_LIST         "    List all registered channels."
#define CS_OHELP_MARK         "    Flag a channel as 'Marked'."
#define CS_OHELP_OHELP        "    To see this help message."
#define CS_OHELP_OFFICIAL     "Mark a channel as a network official."
#define CS_OHELP_OP           ""
#define CS_OHELP_REGISTER     ""
#define CS_OHELP_REMOVE       ""
#define CS_OHELP_SENDPASS     ""
#define CS_OHELP_SET          ""
#define CS_OHELP_TOPIC        "   Force a channel topic change."
#define CS_OHELP_UNBAN        ""
#define CS_OHELP_WHEN         ""
#define CS_OHELP_WHY          ""


#define MS_OHELP_CSEND       ""
#define MS_OHELP_DEL         ""
#define MS_OHELP_DELNEWS     "  Delete a news report."
#define MS_OHELP_FORWARD     ""
#define MS_OHELP_GLOBAL      " Send a global memo to all registered nicks."
#define MS_OHELP_OHELP       "    Show this help message."
#define MS_OHELP_HELP        ""
#define MS_OHELP_NEWS        ""
#define MS_OHELP_OSEND       "    Send a memo to all SOP/SA/SRA members."
#define MS_OHELP_PURGE       ""
#define MS_OHELP_READ        ""
#define MS_OHELP_RESETNEWS   "Reset news database."
#define MS_OHELP_SEND        ""
#define MS_OHELP_SENT        ""
#define MS_OHELP_SET         ""
#define MS_OHELP_UNSEND      ""
#define MS_OHELP_UNDEL       ""


/* General Strings */

#define WELCOME_NOTICE  "Welcome to %s, %s! Your nick is unregistered. Here on %s, we provide our users with services that allow you to own your own nicks and channels. For more information, type: \2/msg %s help\2 or \2/msg %s help\2."


#define NS_REGISTER    "REGISTER successful: Nickname \2%s\2 registered under your account."
#define NS_REGISTER2   "Your password is \2%s\2 - remember this for later use. Write it down!"
#define NS_REGISTER3   "You will receive an e-mail shortly asking for authorization. By following the e-mail's authorization instructions you will be securing your nick and taking a step to reduce the risk of someone exploiting your registrations."
#define NS_REGISTER4   "\2IMPORTANT\2: If you do not authorize your nick you will be limited to only a few commands. i.e: you will not be able to register a channel or set various nick options, etc."

#define NS_BAD_PASS    "IDENTIFY ERROR: Password incorrect for nick '%s'."
#define NS_IDENTIFY    "Password accepted for \2%s\2. You are now identified."
#define NS_REGISTER_DELAY   "You may not use the REGISTER command again for a short period. Please try again in a few moments."

#define CS_REGISTER	"REGISTER successful: Channel %s registered under your nickname: %s."
#define CS_REGISTER2	"Your channel password is \2%s\2 - remember it for later use."
#define CS_REGISTER3    "By default, %s is set to \2%s\2"
#define CS_REGISTER4   "You will receive an e-mail shortly asking for authorization. By following the e-mail's authorization instructions you will be securing your channel and taking a step to reduce the risk of someone exploiting your registrations."
#define CS_REGISTER5   "\2IMPORTANT\2: If you do not authorize your channel it will expire in %d days."

#define CS_BAD_PASS    "IDENTIFY ERROR: Password incorrect for channel '%s'."
#define CS_IDENTIFY    "Password accepted for channel \2%s\2. You now have SET command permissions."

#define MS_NEWMEMO     "You have just received a new memo."
#define MS_NEWMEMO2    "Type \2/%s READ %d\2 to read it."
#define MS_NEWMEMOS    "You have \2%d\2 new memos."
#define MS_MEMO_WAIT   "Please wait briefly before sending another memo."


#define INVALID_EMAIL "ERROR: Invalid email address. Must be in the form of 'username@email.com', must not be of exceeding long length, and may not start with a '@' or a number."
#define BAD_EMAIL     "ERROR: The email address you have given has been banned from the network for any number of reasons. Please try again with another email host."
#define MAX_EMAIL_REACHED "Sorry, this e-mail host is currently at it's full queue for receiving messages. Try again later."
#define MAX_NICKS_REACHED "Sorry, the e-mail address \"%s\" has reached it's maximum nick registrations allowed."
#define MAX_CHANS_REACHED "Sorry, the nick \"%s\" has reached it's maximum channel ownerships allowed."

#define OS_RIGNORE      "Removing IGNORE for %s [Time Expired]"
#define OS_RAKILL	"Removing AKILL for %s [Time Expired]"
#define D_CLONES       "\2WARNING\2: Possible clones detected from %s [%d]"
#define D_IPCLONES      "\2WARNING\2: Possible clones detected from ip %s [%d] (/%s CLONES %s for more info.)"
#define CKILL_REASON    "This host was found cloning."

/*****************************************************************/
/*****************************************************************/


#endif /* MESSAGES_H */

