#!/bin/sh
#

VERSION="$1"
DATE="`date`"

if [ -f ../inc/version.h ] ; then
	BUILD=`fgrep '#define BUILD' ../inc/version.h | sed 's/^#define BUILD.*"\([0-9]*\)".*$/\1/'`
	BUILD=`expr $BUILD + 1`
else
	BUILD=1
fi
cat >../inc/version.h <<EOF

#ifndef VERSION_H
#define VERSION_H

#define BUILD	"$BUILD"

#define version_number "$VERSION"
#define version_build "build #$BUILD, compiled on $DATE"


#endif /* VERSION_H */
EOF
