/*
 * SirvNET Services are copyright (c) 1998-2006 Trevor Klingbeil.
 *    http://www.sirv.net  ::  ftp.sirv.net
 * This program is copyrighted software; see the file COPYING for details.
 */

#include "services.h"

/****************************************************************************/

Masters *masterlist = NULL;
BadEmails *bademails = NULL;

char *log_name = "services.log";
char *conf_name = "services.conf";
char *allow_conf = "allow.conf";
char *email_conf = "bad.emails";

char *remote_servername = NULL;
char *remote_server = NULL;
unsigned long services_port = 0;
char *services_pass = NULL;
char *servername = NULL;
char *services_desc = NULL;
char *services_user = NULL;
char *services_host = NULL;
char *NETWORK_NAME = DEF_NET;
char *sirv_masters = NULL;
char *statsname = NULL;



char *s_NickServ = DEF_NS;
char *s_ChanServ = DEF_CS;
char *s_MemoServ = DEF_MS;
char *s_OperServ = DEF_OS;
char *s_RootServ = DEF_RS;
char *s_HelpServ = DEF_HS;
char *s_StatServ = DEF_SS;
char *s_Global   = DEF_GM;

char *SQL_HOST = "localhost";
char *SQL_USER = NULL;
char *SQL_PASS = NULL;
char *SQL_DB = NULL;
int SQL_PORT = 3306;



int READ_ONLY = 0;

int TIMEOUT_CHECK;
int SQL_CHECK;
int CONNECT;
int RECONNECT;
int RECON_FREQ;
int SERV_LISTEN_PORT;

char *local_ip = NULL;

char *allow_ips[24];
unsigned int ip_num = 0;


short ALLOW_EMAIL;
short AUTH_EMAIL;
short NSECURE;
short LOGON_NEWS;
short GENERIC_NOTICE;
short ORGANIZE;
char *SENDMAIL_PATH;
char *RETURN_EMAIL;
short BAD_PW_LIMIT;
short BAD_PW_TIMEOUT;
short ENABLE_R_MODES;
short FLOOD_PROT;
short F_TLEV;
short F_RESET;
short ACCESS_MAX;
short DISABLE_PRIVMSG;
short ENABLE_GETPASS;
int BLOCK_EMAIL_TIME;
char *HELPSERV_DIR;
short HIGH_NICK_SECURITY;
int XAUTH_TIME;
int NICK_EXPIRE;
unsigned long UPDATE_TIMEOUT;
short DISPLAY_UPDATES;
short ALLOW_LIST;
int LIST_MAX;
int MAX_EMAILS;
short FORBID_OPERS;
short SNOOP;
char *SNOOPCHAN = "#Snoop";
short MOTD_UPTIME;
float AKILL_PERCENT = 30.0;
short DETECT_CLONES;
short CLONE_MIN_USERS;
short CLONE_WARNING_DELAY;
short LOG_IDENTIFIES;
int NS_REG_DELAY;
short sdebug;
short SEND_LOGS;
char *CKILL_TIME;
char *CKILL_WHO;
short CKILL_COUNT;
char *DEF_MLOCKS;
int CHAN_EXPIRE;
short CHAN_ACC_MAX;
short CHAN_LIST_MAX;
short CHAN_REMOVE;
short CHAN_INHABIT;
short REMINDER_DAYS;
int MAX_MEMO_LENGTH;
short MAX_MEMOS;
short MEMO_WAIT;
int MEMO_EXPIRE;
int RELEASE_TIMEOUT;
short MAX_NICKS;
short MAX_CHANS;
short AKILL_REASONS;
char *SMTP_SERVER;
char *SMTP_LOGIN;
char *SMTP_PASS;
short ALLOW_LITERAL;
int TRIMBANS;
int TRIMBANS_REMOVE;
short DEF_NS_ENFORCE;
short DEF_NS_SECURE;
short DEF_NS_HIDE;
short DEF_CS_KEEPTOPIC;
short DEF_CS_IDENT;
int FORCE_MEMO_LEVEL;
short MASK_HOSTNAME;
short BACKUP_DB;
unsigned long BACKUP_UPDATE;
short WEB_UPDATE;
short WEB_UPDATE_HOURS;
short DISPLAY_VERSION;
short CHANNEL_AUTH;
int SMTP_RESEND_TIME;
int SMTP_RETRIES;

/****************************************************************************/

typedef struct {
	const char *opt;
	char *str;
	int value;
	int mem;
} Option;

Option options[] = {
	{ "NICKSERV",	DEF_NS,	-1,	0 },
	{ "CHANSERV",	DEF_CS,	-1,	0 },
	{ "MEMOSERV",	DEF_MS,	-1,	0 },
	{ "HELPSERV",	DEF_HS,	-1,	0 },
	{ "OPERSERV",	DEF_OS,	-1,	0 },
	{ "ROOTSERV",	DEF_RS,	-1,	0 },
	{ "GLOBAL",	DEF_GM,	-1,	0 },
	{ "STATSERV",	DEF_SS,	-1,	0 },
	{ "READONLY", 	NULL,	0,	0 },
	{ "TIMEOUT", 	NULL,	2,	0 },
	{ "SQLTIMEOUT", 	NULL,	60,	0 },
	{ "CONNECT", 	NULL,	2,	0 },
	{ "RECONNECT", 	NULL,	1,	0 },
	{ "RECONNECT_TIME", 	NULL,	20,	0 },
	{ "LPORT",	NULL,	7325,	0 },
	{ "R_MODES", 	NULL,	1,	0 },
	{ "U_ACC_MAX", 	NULL,	20,	0 },
	{ "EMAIL", 	NULL,	1,	0 },
	{ "REGEMAIL", 	NULL,	1,	0 },
	{ "XAUTH", 	NULL,	1, 	0 },
	{ "LOGONNEWS", 	NULL,	0, 	0 },
	{ "GENERIC", 	NULL,	1,	0 },
	{ "GETPASS", 	NULL,	0,	0 },
	{ "BLOCKTIME", 	NULL,	21600,	0 },
	{ "SECURITY", 	NULL,	1,	0 },
	{ "XAUTH_TIME", 	NULL,	3,	0 },
	{ "NICKEXP", 	NULL,	30,	0 },
	{ "UPDATE", 	NULL,	1800,	0 },
	{ "DISPLAY_UPDATES", 	NULL,	1,	0 },
	{ "LIST", 	NULL,	1,	0 },
	{ "DEBUG", 	NULL,	0,	0 },
	{ "SENDMAIL", 	"/usr/sbin/sendmail -t",	-1,	0 },
	{ "RETURN", 	"sirv@localhost",	-1,	0 },
	{ "ORGANIZE", 	NULL,	1,	0 },
	{ "PW_LIMIT", 	NULL,	5,	0 },
	{ "PW_TIMEOUT", 	NULL,	3600,	0 },
	{ "SET_FLOOD", 	NULL,	1,	0 },
	{ "TLEV", 	NULL,	10,	0 },
	{ "RESET", 	NULL,	15,	0 },
	{ "PRIVMSG", 	NULL,	0,	0 },
	{ "HELP", 	"helpfiles",	-1,	0 },
	{ "LISTMAX", 	NULL,	50,	0 },
	{ "MAX_EMAILS",	NULL,	20,	0 },
	{ "FORBID_OPERS",	NULL,	1,	0 },
	{ "SNOOP",	NULL,	1,	0 },
	{ "SNOOPCHAN",	"#Snoop",	-1,	0 },
	{ "MOTD_UPTIME",	NULL,	1,	0 },
	{ "PERCENT",	NULL,	30,	0 },
	{ "SET_CLONES",	NULL,	1,	0 },
	{ "CLONES",	NULL,	5,	0 },
	{ "CLONE_WARN",	NULL,	10,	0 },
	{ "IDENTIFIES",	NULL,	0,	0 },
	{ "REG_DELAY",	NULL,	30,	0 },
	{ "SDEBUG",	NULL,	0,	0 },
	{ "SENDLOGS",	NULL,	1,	0 },
	{ "CLONETIME",	"30m",	-1,	0 },
	{ "CLONEWHO",	"services",	-1,	0 },
	{ "CLONEKILL",	NULL,	0,	0 },
	{ "MLOCK",	"+nt",	-1,	0 },
	{ "CHANEXP", 	NULL,	30,	0 },
	{ "C_ACC_MAX", 	NULL,	1000,	0 },
	{ "C_LIST_MAX",	NULL,	250,	0 },
	{ "CREMOVE",	NULL,	1,	0 },
	{ "INHABIT",	NULL,	30,	0 },
	{ "REMIND",	NULL,	3,	0 },
	{ "MEMO_LEN",	NULL,	255,	0 },
	{ "MEMOMAX",	NULL,	50,	0 },
	{ "MEMO_WAIT",	NULL,	15,	0 },
	{ "MEMOEXP",	NULL,	30,	0 },
	{ "RELEASE",	NULL,	60,	0 },
	{ "NICKREG",	NULL,	10,	0 },
	{ "CHANREG",	NULL,	10,	0 },
	{ "AREASONS",	NULL,	1,	0 },
	{ "SMTP",	NULL,	-1,	0 },
	{ "LOGIN",	NULL,	-1,	0 },
	{ "PASS",	NULL,	-1,	0 },
	{ "LITERAL",	NULL,	0,	0 },
	{ "TRIMBANS",	NULL,	95,	0 },
	{ "TRIMNUM",	NULL,	16,	0 },
	{ "NICKENF",	NULL,	0,	0 },
	{ "NICKSEC",	NULL,	0,	0 },
	{ "NICKHIDE",	NULL,	1,	0 },
	{ "CHANIDENT",	NULL,	0,	0 },
	{ "CHANTOPIC",	NULL,	1,	0 },
	{ "FORCEMEMO",	NULL,	1,	0 },
	{ "HIDEHOST",	NULL,	0,	0 },
	{ "BACKUP",	NULL,	0,	0 },
	{ "BACKUP_TIME",	NULL,	12,	0 },
	{ "WEBUPDATE",	NULL,	1,	0 },
	{ "WEBHOURS",	NULL,	24,	0 },
	{ "SHOWVERSION",	NULL,	1,	0 },
	{ "CHANAUTH",	NULL,	1,	0 },
	{ "SMTP_TIME",	NULL,	3600,	0 },
	{ "SMTP_RETRY",	NULL,	3,	0 },

	{ NULL }
};

/****************************************************************************/

static void set_conf()
{
	s_NickServ = options[0].str;
	s_ChanServ = options[1].str;
	s_MemoServ = options[2].str;
	s_HelpServ = options[3].str;
	s_OperServ = options[4].str;
	s_RootServ = options[5].str;
	s_Global = options[6].str;
	s_StatServ = options[7].str;
	if (READ_ONLY != 2)
		READ_ONLY = options[8].value;
	TIMEOUT_CHECK = options[9].value;
	SQL_CHECK = options[10].value;
	CONNECT = options[11].value;
	RECONNECT = options[12].value;
	RECON_FREQ = options[13].value;
	SERV_LISTEN_PORT = options[14].value;
	ENABLE_R_MODES = options[15].value;
	ACCESS_MAX = options[16].value;
	ALLOW_EMAIL = options[17].value;
	AUTH_EMAIL = options[18].value;
	NSECURE = options[19].value;
	LOGON_NEWS = options[20].value;
	GENERIC_NOTICE = options[21].value;
	ENABLE_GETPASS = options[22].value;
	BLOCK_EMAIL_TIME = options[23].value;
	HIGH_NICK_SECURITY = options[24].value;
	XAUTH_TIME = options[25].value;
	NICK_EXPIRE = options[26].value;
	UPDATE_TIMEOUT = options[27].value;
	DISPLAY_UPDATES = options[28].value;
	ALLOW_LIST = options[29].value;
	if (debug != 2)
		debug = options[30].value;
	SENDMAIL_PATH = options[31].str;
	RETURN_EMAIL = options[32].str;
	ORGANIZE = options[33].value;
	BAD_PW_LIMIT = options[34].value;
	BAD_PW_TIMEOUT = options[35].value;
	FLOOD_PROT = options[36].value;
	F_TLEV = options[37].value;
	F_RESET = options[38].value;
	DISABLE_PRIVMSG = options[39].value;
	HELPSERV_DIR = options[40].str;
	LIST_MAX = options[41].value;
	MAX_EMAILS = options[42].value;
	FORBID_OPERS = options[43].value;
	SNOOP = options[44].value;
	SNOOPCHAN = options[45].str;
	MOTD_UPTIME = options[46].value;
	AKILL_PERCENT = (float)options[47].value;
	DETECT_CLONES = options[48].value;
	CLONE_MIN_USERS = options[49].value;
	CLONE_WARNING_DELAY = options[50].value;
	LOG_IDENTIFIES = options[51].value;
	NS_REG_DELAY = options[52].value;
	sdebug = options[53].value;
	SEND_LOGS = options[54].value;
	CKILL_TIME = options[55].str;
	CKILL_WHO = options[56].str;
	CKILL_COUNT = options[57].value;
	DEF_MLOCKS = options[58].str;
	CHAN_EXPIRE = options[59].value;
	CHAN_ACC_MAX = options[60].value;
        CHAN_LIST_MAX = options[61].value;
        CHAN_REMOVE = options[62].value;
        CHAN_INHABIT = options[63].value;
        REMINDER_DAYS = options[64].value;
        MAX_MEMO_LENGTH = options[65].value;
        MAX_MEMOS = options[66].value;
        MEMO_WAIT = options[67].value;
        MEMO_EXPIRE = options[68].value;
        RELEASE_TIMEOUT = options[69].value;
	MAX_NICKS = options[70].value;
	MAX_CHANS = options[71].value;
	AKILL_REASONS = options[72].value;
	SMTP_SERVER = options[73].str;
	SMTP_LOGIN = options[74].str;
	SMTP_PASS = options[75].str;
	ALLOW_LITERAL = options[76].value;
	TRIMBANS = options[77].value;
	TRIMBANS_REMOVE = options[78].value;
	DEF_NS_ENFORCE = options[79].value;
	DEF_NS_SECURE = options[80].value;
	DEF_NS_HIDE = options[81].value;
	DEF_CS_IDENT = options[82].value;
	DEF_CS_KEEPTOPIC = options[83].value;
	FORCE_MEMO_LEVEL = options[84].value;
	MASK_HOSTNAME = options[85].value;
	BACKUP_DB = options[86].value;
	BACKUP_UPDATE = options[87].value;
	WEB_UPDATE = options[88].value;
	WEB_UPDATE_HOURS = options[89].value;
	DISPLAY_VERSION = options[90].value;
	CHANNEL_AUTH = options[91].value;
	SMTP_RESEND_TIME = options[92].value;
	SMTP_RETRIES = options[93].value;

	if (RECON_FREQ < 20)
		fatal_error("Error in Option \"RECONNECT_TIME\": Value must be greater than 20");
	if (TIMEOUT_CHECK < 0 || TIMEOUT_CHECK > 15)
		fatal_error("Error in Option \"TIMEOUT\": Value must be between 0-15");
	if (SQL_CHECK < 5 || SQL_CHECK > 3600)
		fatal_error("Error in Option \"SQLTIMEOUT\": Value must be between 5-3600");
	if (strlen(SQL_DB) > 64)
		fatal_error("Error in Option \"SQL_DB\": Database name my not exceed 64 characters!");
	if (*SNOOPCHAN != '#' && *SNOOPCHAN != '&')
		fatal_error("Invalid channel for Option \"SNOOPCHAN\"");
	if (AKILL_PERCENT < 0 || AKILL_PERCENT > 101)
		fatal_error("Error in Option \"PERCENT\": Value must be between 0-100");
	if ((strlen(DEF_MLOCKS) > 1) && (strspn(DEF_MLOCKS, "+-cimnprstR") != strlen(DEF_MLOCKS)))
		fatal_error("Error in Options \"MLOCK\": Invalid modes.");
	if (CHAN_INHABIT < 5 || CHAN_INHABIT > 7200)
		fatal_error("Error in Options \"INHABIT\": Value must be between 5-7200.");
	if (MEMO_WAIT < 5 || MEMO_WAIT > 7200)
		fatal_error("Error in Options \"MEMO_WAIT\": Value must be between 5-7200.");
	if (!ALLOW_EMAIL && AUTH_EMAIL)
		fatal_error("ERROR: Must have EMAIL enabled to use REGEMAIL");
	if (!AUTH_EMAIL && NSECURE)
		fatal_error("ERROR: Must have EMAIL enabled to use XAUTH");
	if (FORCE_MEMO_LEVEL < 0 || FORCE_MEMO_LEVEL > 5)
		fatal_error("ERROR: FORCE_MEMO_LEVEL must be between 0 and 4!");


}

/****************************************************************************/

static void init_allow_conf()
{
	FILE *conf;
	char linebuf[24];
	char *tmp, allowconf[512];
	char *a1, *a2, *a3, *a4;
	int a5=0;

	if (sshutdown != -1 && ip_num > 0) {
		unsigned int i;
		for (i=0; i < ip_num; i++)
			free(allow_ips[i]);
		ip_num=0;
	}

	snprintf(allowconf, sizeof(allowconf), "%s/%s", CONFDIR, allow_conf);
	if ((conf = fopen(allowconf, "rb")) == NULL)
		fatal_error("can't open configuration file = %s", allowconf);
	while (!feof(conf)) {
		tmp=NULL;
		if ((fgets(linebuf, 24, conf)) == NULL)
			break;

		tmp = strtok(linebuf, "\n\r,");
		if (!tmp || (*tmp == '\n'))
			continue;  /* blank line in conf file */


		tmp = sstrdup(linebuf);

		a1 = strtok(linebuf, "."); a2 = strtok(NULL, ".");
		a3 = strtok(NULL, "."); a4 = strtok(NULL, "");

		if (a4)
			a5 = ((strspn(a4, "123456789") != strlen(a4)) && (strlen(a4) > 3));

		if (!a1 || !a2 || !a3 || !a4 || a5)
			fatal_error("Invalid IP address in %s file: %s",
				allowconf, tmp);


		if (((atoi(a1) < 1) || (atoi(a1) > 255)) ||
			(atoi(a2) < 0) || (atoi(a2) > 255) ||
			(atoi(a3) < 0) || (atoi(a3) > 255) ||
			(atoi(a4) < 0) || (atoi(a4) > 255))

			fatal_error("Invalid IP address in %s file: %s",
				allowconf, tmp);



		allow_ips[ip_num++] = sstrdup(tmp);
		free(tmp);
	}
	if (!ip_num)
		fatal_error("No valid IP address(es) found in %s file!", allowconf);
}


/****************************************************************************/

static void init_bademail()
{
	FILE *conf;
	BadEmails *cur, *next;
	char linebuf[512];
	char *tmp, emailconf[512];
	int count=0;

	if (sshutdown != -1) {
		cur = bademails;
		while (cur) {
			next = cur->next;
			free(cur->host); free(cur);
			cur = next;
		}
		bademails = NULL;
	}


	snprintf(emailconf, sizeof(emailconf), "%s/%s", CONFDIR, email_conf);
	if ((conf = fopen(emailconf, "rb")) == NULL)
		return;

	while (!feof(conf)) {
		if ((fgets(linebuf, 512, conf)) == NULL)
			break;

		tmp = strtok(linebuf, "\n\r,");

		if (!tmp || (*tmp == '\n'))
			continue;  /* blank line in conf file */

		tmp = sstrdup(linebuf);

		if ((*tmp == '\n')) {
			free(tmp);
			continue;  /* blank line in conf file */
		}

		cur = scalloc(sizeof(BadEmails), 1);
		cur->host = sstrdup(tmp);
		if (bademails)
			cur->next = bademails;
		bademails = cur;
		free(tmp);
		count++;
	}
	fprintf(stderr, "      (4): bad.emails loaded (%d entr%s)\n",
		count, count==1 ? "y" : "ies");

}

/****************************************************************************/

static int conf_break(int pargc, char **pargv)
{
	Option *opt;
	char buf[64];
	int i, valid=0;

	*buf = 0;

	if (strlen(pargv[0]) > 1) {
		strcat(buf, pargv[0]);


		if (sstrcmp(buf, "SENDMAIL") == 0) {
			if (pargc < 2)
				fatal_error("Error in Option \"%s\"", pargv[0]);
			*buf = 0;
			i=1;

			while(i < pargc) {
				strcat(buf, pargv[i]);
				i++;
				if (i < pargc)
					strcat(buf, " ");
			}
			SENDMAIL_PATH = sstrdup(buf);
			return 1;

		}

		if (pargc != 2)
			fatal_error("Error in Option \"%s\"", pargv[0]);


		for (opt = options; opt->opt; opt++) {
			if (sstrcmp(opt->opt, buf) == 0) {
				if (opt->value == -1) {
					if (opt->mem)
						free(opt->str);
					opt->str = sstrdup(pargv[1]);
					opt->mem = 1;
				} else
					opt->value = atoi(pargv[1]);
				valid=1;
				break;
			}
		}

		if (valid)
			return 1;
		else
			fatal_error("Unknown Option \"%s\" in %s", pargv[0], conf_name);


		}

	if (*pargv[0] == 'M') {
			Masters *m;
			int z;

			if (pargc < 2)
				fatal_error("Invalid M: line");

			if (sshutdown != -1) {
				Masters *cur = masterlist, *next;
				while (cur) {
					free(cur->nick);
					next = cur->next;
					free(cur);
					cur = next;
				}
			}

			m = scalloc(sizeof(Masters), 1);
			m->nick = sstrdup(pargv[1]);
			masterlist = m;

			for (z=2; z < pargc; z++) {
				Masters *m2, *mcheck;
				for (mcheck = masterlist; mcheck; mcheck = mcheck->next) {
					if (sstrcmp(mcheck->nick, pargv[z]) == 0) {
						fatal_error("%s defined multiple times as root master!",
							pargv[z]);
					}
				}
				m2 = scalloc(sizeof(Masters), 1);
				m2->nick = sstrdup(pargv[z]);
				m2->next = NULL;
				m->next = m2;
				m = m2;
			}
			if (sshutdown == -1)
				fprintf(stderr, "      (4): Running with %d root master%s\n",
					pargc-1, pargc == 2 ? "" : "s");
			return 1;

	}

	if (sshutdown > -1)  /* REHASH ends here */
		return 1;

	switch (pargv[0][0])
	{

		case '#':
			return 0;
		case 'C':
		{
			if (pargc != 5)
				fatal_error("Invalid C: line");
			remote_servername = sstrdup(pargv[1]);
			remote_server = sstrdup(pargv[2]);
			services_pass = sstrdup(pargv[3]);
			services_port = atoi(pargv[4]);
			return 1;
		}

		case 'I':
		{
			if (pargc != 4)
				fatal_error("Invalid I: line");
			servername = sstrdup(pargv[1]);
			services_user = sstrdup(pargv[2]);
			services_host = sstrdup(pargv[3]);
			return 1;
		}

		case 'D':
		{
			if (pargc == 0)
				fatal_error("Invalid D: line (%s), DESC must contain at least 1 param",
					conf_name);
			*buf = 0;
			i=1;

			while(i < pargc) {
				strcat(buf, pargv[i]);
				i++;
				if (i < pargc)
					strcat(buf, " ");
			}
			services_desc = sstrdup(buf);
			return 1;
		}

		case 'N':
		{
			if (pargc != 2)
				fatal_error("Invalid N: line");
			NETWORK_NAME = sstrdup(pargv[1]);
			return 1;
		}
		case 'M':
		{
			return 1;  /* 'M' is caught just above switch. */
		}

		case 'S':
		{
			if (pargc != 2)
				fatal_error("Invalid S: line");
			statsname = sstrdup(pargv[1]);
			return 1;
		}
		case 'X':
		{
			if (pargc != 6)
				fatal_error("Invalid X: line");
			SQL_HOST = sstrdup(pargv[1]);
			SQL_USER = sstrdup(pargv[2]);
			SQL_PASS = sstrdup(pargv[3]);
			SQL_DB = sstrdup(pargv[4]);
			SQL_PORT = atoi(pargv[5]);
			return 1;
		}
		default:
		{
			fatal_error("Unknown Field in %s conf file: (%c)\n",
				conf_name, pargv[0][0]);
			return 0;
		}
	}

return 1;
}

/****************************************************************************/



static void init_servconf()
{

	FILE *conf_file;
	char linebuf[1024];
	char *pargv[100];
	char *tmp, conf[512];
	int p, i;

	snprintf(conf, sizeof(conf), "%s/%s", CONFDIR, conf_name);
	if ((conf_file = fopen(conf, "rb")) == NULL)
		fatal_error("can't open configuration file = %s", conf);
	while (!feof(conf_file)) {
		if ((fgets(linebuf, 1024, conf_file)) == NULL)
			break;
		p = 0;
		tmp = strtok(linebuf, ": \n\r,");

		if (tmp != NULL) {
			pargv[p++] = tmp;
			for(i=0; i < 3; i++) {
				while ((tmp = strtok(NULL, ": \n\r,")) != NULL) {
					pargv[p++] = tmp;
					if (p > 100)
						break;
				}
			}
			if (conf_break(p, pargv) == -1)
				fatal_error("Sirv terminated on illegal configuration");
		}
	}
	fclose(conf_file);
	if (!masterlist)
		fatal_error("%s: Missing M: line", conf_name);
	else if (!remote_servername || !remote_server || !services_port || !services_pass)
		fatal_error("%s: Missing C: line", conf_name);
	else if (!statsname)
		fatal_error("%s: Missing S: line", conf_name);
	else if (!servername || !services_user || !services_host)
		fatal_error("%s: Missing I: line", conf_name);
	else if (!services_desc)
		fatal_error("%s: Missing D: line", conf_name);
	else if (!NETWORK_NAME)
		fatal_error("%s: Missing N: line", conf_name);
	else if (!SQL_HOST || !SQL_USER || !SQL_PASS || !SQL_DB)
		fatal_error("%s: Missing X: line", conf_name);
	else if (strlen(NETWORK_NAME) > 64)
		fatal_error("Network name '%s' too long.");

}


/****************************************************************************/

int init_conf()
{

	init_servconf();
	set_conf();
	if (CONNECT != 1)
		init_allow_conf();
	init_operconf();
	init_bademail();

	return 1;
}




/****************************************************************************/
/****************************************************************************/

